<?php
/*
 * DaPhpBouchot / lib.post.php
 * (c) 2002-07 Alexandre Janon <alex14fr at yahoo dot fr>
 */

function score_words($words,$message) {
  	$score=0;
	$nw=1;
       	$n=strlen($message);
	foreach($words as $word) {
	  	$p=strlen($word);
		$i=strpos(strtolower($message),$word); 
		while(!($i===FALSE)) {
		  $nw=$nw*(1+rand(1,256)/512);
		  $score+=$nw;
		  $noffs=$i+$p-1; 
		  if($noffs>=$n) {
		    $i=FALSE;
		  } else {
		    $i=strpos(strtolower($message),$word,$noffs); 
		  }
		}
	}
	return($score);
}

function post_spamicity($message,$test,$ignoreua=FALSE) {
  	$spam_words=array("viagra","http","nice site","hi","llll","try","[url]","[/url]","thanks","good site","best","check it","<a>","</a>","32");
	$ham_words=array("oui","non","et","ou","est","en","donc","mais");

	$score=0;

  	$login=user_get();
	$ua=$_SERVER["HTTP_USER_AGENT"];

	if(!$ignoreua) {
		$login=user_get();
		$ua=$_SERVER["HTTP_USER_AGENT"];
		if(captcha::check() || (!empty($login)) && (!$test)) return 0;
		if(empty($ua)) $score+=0.5;
		if(strpos(strtolower($ua), "coincoin")>0) $score-=0.5;
	}

	$score+=0.5*score_words($spam_words,$message)-0.25*score_words($ham_words,$message);

	if($test) {
	  	echo "<br/>spamicity=$score"; 
	}

	if(!$test && !$ignoreua) {
		$f=fopen("spam.log","a");
		fwrite($f,"msg=$message;; score=$score\r\n");
		fclose($f);
	}

	return($score);
}


function html_filter($msg) {
	global $htmlok;
	$msg = preg_replace("/style( )*=/i","styl e=",$msg);
	$msg = preg_replace("/class( )*=/i","clas s=",$msg);
	$msg = preg_replace("/\&/","&amp;",$msg);
	$msg = preg_replace("/on(dbl|click|focus|mouse|blur|load|unload)/i","on \\1",$msg);
	$msg = preg_replace("/javascript:/i","java script:",$msg);
	$indic = array();
	foreach($htmlok as $html) 
		$indic[$html]=0;
	for($i=0 ; $i<strlen($msg) ; $i++) {
		$balise = "";
		$ok = true;
		if($msg{$i}=="<" && $msg{$i+1}!="/" && $msg{$i+1}!=" ") {
			$ok = false;
			for($j=0 ; $j<sizeof($htmlok) ; $j++) {
				$b=$htmlok[$j];
				for($t=true,$k=0 ; $k<strlen($b); $k++) {
					if($msg{$i+$k+1} != $b{$k}) {
						$t=false;
						break;
					} else 
						$balise .= $b{$k};
				}
				if($t) {
					$n=strlen($b)+1;
					if($msg{$i+$n} == " " || $msg{$i+$n} == ">" || $msg{$i+$n} == "-" ) {
						$ok=true;
						$indic[$balise]++;	
						break;
					}
				}
			}
		}
		else if($msg{$i}=="<" && $msg{$i+1}=="/") {
			$ok = false;
			for($j=2 ; $i+$j<=strlen($msg) && $msg{$i+$j}!=">" ; $j++) 
				$balise .= $msg{$i+$j};
			foreach($htmlok as $html) {
				if($html == $balise) {
					$ok = true;
					break;
				}
			}
                        $indic[$balise]--;
			if($indic[$balise]<0) { $ok=false; $indic[$balise]=0; }
		}
		if(!$ok) {
			$newmsg = "";
			for($j=0 ; $j<$i ; $j++) $newmsg .= $msg{$j};
			$newmsg .= "&lt;";
			$i++;
			for($j=$i; $j<strlen($msg) ; $j++) $newmsg .= $msg{$j};
			$msg = $newmsg;
		}
	}
	foreach($htmlok as $html) {
		$ind=$indic[$html];
		for($i=0 ; $i<$ind ; $i++) 
			$msg .= "</".$html.">";
	}
	return $msg;
}

function isplonked($ip) {
	if($r = db_fetch(db_query("SELECT ip,message FROM plonk WHERE ip='$ip'"))) 
		return $r["message"];
	else 
		return "";
}

function post_add($message) {
	global $allowanon;
	global $doublepost;
	global $admin;
	global $maxword;
	global $norikvm;

	$ip = $_SERVER["REMOTE_ADDR"];

	/* plonk ? */
	$pmsg = isplonked($ip);
	if(!empty($pmsg))
		die("PLONK ! ".$pmsg);

	/* authentification */
	$login=user_get();

	/* post anonyme ? */
	if(empty($login) && $allowanon == false) 
		die("Daisolai mais l'admin ne veut pas de posts anonymes...");

	/* utilisateur plonk ? */
	$pmsg = isplonked($login);
	if(!empty($pmsg))
		die("PLONK ! ".$pmsg);

	$lastmsg = db_fetch(db_query("select id,ip,msg from bouchot order by id desc"));

	if(preg_match("/^\/master/", $message)) {
		db_query("INSERT INTO bouchot (ip,user,ua,msg) VALUES('0.0.0.0 / $ip','Admin','Admin/42','<b>$admin</b> est mon matre')");
		genindex(); genbackend(); return;
	}

	if(preg_match("/^\/plonked/", $message)) {
		$q=db_query("SELECT ip FROM plonk");
		$out = "Plonks: ";
		while($r=db_fetch($q)) {
			$out .= $r["ip"]." ";
		}
		db_query("INSERT INTO bouchot (ip,user,ua,msg) VALUES('0.0.0.0 / $ip','Admin','Admin/42','$out')");
		genindex(); genbackend(); return;
	}

	if(preg_match("/^\/plonk ([^ ]+) (.+)/", $message, $matches)) {
		if(!user_is_admin()) {
			die("You bad boy...");
		}
		$i=$matches[1];
		$re=$matches[2];
		db_query("INSERT INTO plonk (ip,message) VALUES('$i','$re')");
		db_query("INSERT INTO bouchot (ip,user,ua,msg) VALUES('0.0.0.0 / $ip','Admin','Admin/42','<b>$i</b> plonk ($re)')");
		genindex(); genbackend(); return;
	}

	if(preg_match("/^\/deplonk (.+)/", $message, $matches)) {
		if(!user_is_admin()) {
			die("You bad boy...");
		}
		$i=$matches[1];
		db_query("DELETE FROM plonk WHERE ip='$i'");
		db_query("INSERT INTO bouchot (ip,user,ua,msg) VALUES('0.0.0.0 / $ip','Admin','Admin/42','<b>$i</b> dplonk')");
		genindex(); genbackend(); return;
	}

	if(preg_match("/^\/sifflote (.+)/", $message, $matches)) {
		if(!user_is_admin()) {
			die("You bad boy...");
		}
		$m=$matches[1];
		$a=explode(" ", $m);
		for($i=0;$i<sizeof($a);$i++) {
			$n=$a[$i];
			db_query("DELETE FROM bouchot WHERE id='$n'");
		}
	//	db_query("INSERT INTO bouchot (ip,user,ua,msg) VALUES('0.0.0.0 / $ip','Admin','Admin/42','<b>$m</b> sifflot')");
		genindex(); genbackend(); return;
	}

	if(preg_match("/^\/msifflote ([^ ]+) (.+)/", $message, $matches)) {
		if(!user_is_admin()) { die("You bad boy..."); }
		$i=$matches[1]; $j=$matches[2];
		db_query("DELETE FROM bouchot WHERE id>=$i AND id<=$j");
		genindex(); genbackend(); return;
	}

	/* on regarde si le mec double-poste pas comme un boulay de premire classe */
	if($doublepost == false && $lastmsg["ip"] == $ip) 
		die("Daisolai mais l'admin ne veut pas de double-posts... ");
	$msg=$message;

	if($msg=="") return;

	/* tronquer et rajouter des espaces dans les mots longs */
	for($mcount=0, $i=0, $newmsg="", $inurl=0 ; $i<strlen($msg) ; $i++) {
		if($msg{$i} == " ") {
			$mcount=0;
			$newmsg .= " ";
			if($inurl == 1) 
				$inurl = 0;
		}
		if($inurl && $msg{$i}=="<")  {
			$inurl=0;	
			$msg{$i}=" ";
		} else if($mcount>=$maxword && $inurl==0) {
			$mcount=0;
			$newmsg .= " ";
			$newmsg .= $msg{$i};
		} else {
			$mcount++;
			$newmsg .= $msg{$i};
			if(preg_match("/((ftp|https?)\:\/\/)/",substr($msg,$i,9)))
				$inurl=1;
		}
	}
	$newmsg = html_filter($newmsg);
		
	/* convertir les [url] */
	$newmsg = preg_replace("/((ftp|https?)\:\/\/[^\"\>\< ]+)/","<a href=\"\\1\"><b>[url]</b></a>", $newmsg);

	/* workaround a famous rik's VM(tm) bug */
	if($norikvm == true && $lastmsg["ip"] == $ip && $lastmsg["msg"] == $newmsg) { 
		die("VM  Rik sux<br>VM  Rik sux<br>VM  Rik sux<br>");
	}

	$ua=$_SERVER["HTTP_USER_AGENT"];
	$qry="insert into bouchot (ip,ua,user,msg) values(
		'$ip', 
		'$ua', 
		'$login',
		'$newmsg'
	)";
	db_query($qry);
	genindex(); genbackend();
}

function ts_old2new($ts) {
	return(preg_replace("/[ \-\:]/","",$ts));
}

function get_msgs($nposts, $sess_id) {
	global $smiley;
	$out = "";
	$q = db_query("SELECT ip,id,ua,msg,time,user FROM bouchot ORDER BY id DESC LIMIT ".($nposts+1)); 
	while($r = db_fetch($q)) {
		$time = substr(ts_old2new($r["time"]),8);
		$msg = $r["msg"];
		if(!empty($smiley)) 
			$msg = preg_replace("/\[\:([^\]]+)\]/","<img src=\"$smiley/\\1.gif\" alt=\"[:\\1]\" title=\"[:\\1]\"/>",$msg);
		if(!empty($r["user"])) $user = $r["user"]; else $user="*";
		if(preg_match("/\</",$ua)) $ua = "n4k50r!";
		$out = "<a title=\"$ua\" class=\"horloge\" onclick=\"append('".substr($time,0,2).":".substr($time,2,2).":".substr($time,4,2)." ')\">".substr($time,0,2).":".substr($time,2,2).":".substr($time,4,2)."</a> ".
		     "&lt;<a	href=\"info.php?id=".$r["id"]."\" class=\"login\">".html_filter($user)."</a>&gt; ".
		     "<span class=\"message\">".$msg."</span><br />\n".$out;
	}
	return $out;
}

function get_info($id) {
	$q = db_query("SELECT time,ua,msg,id,ip,user FROM bouchot WHERE id='$id'");
	
	$r = db_fetch($q);

	$time = ts_old2new($r["time"]);
	$ua = htmlentities($r["ua"]);
	$msg = htmlentities($r["msg"]);
	$user = htmlentities($r["user"]);

	$date = substr($time, 6,2)."/".substr($time, 4,2)."/".substr($time, 0, 4);
	$heure = substr($time,8,2).":".substr($time,10,2).":".substr($time, 12, 2);

	$out =  "$date @ $heure<br>$ua<br>";
	$out .= "$user<br>";
	$out .= "Approximate spamicity = ".post_spamicity($r["msg"],FALSE,TRUE)."<br>";
	if(user_is_admin()) 
		$out .= "<br><br>IP: ".$r["ip"]." (".gethostbyaddr($r["ip"]).")";

	$out .= "<br/>$msg<br/>";

	return $out;
}

function genbackend() {
	global $remotesize;
	$backendfile = "remote.xml";

	$q = db_query("SELECT id,ip,ua,msg,time,user FROM bouchot ORDER BY id DESC LIMIT ".($remotesize+1));

	$backend = fopen($backendfile, "w");

	fwrite($backend, "<?xml version=\"1.0\" encoding=\"iso-8859-15\"?>\n");
	fwrite($backend, "<!DOCTYPE board SYSTEM \"remote.dtd\">\n");
	fwrite($backend, "<board>\n");

	while($r = db_fetch($q)) {
		fwrite($backend, "<post time=\"".ts_old2new($r["time"])."\" id=\"".$r["id"]."\">\n");
      		$ua=$r["ua"];
     		if(preg_match("/\</",$ua)) $ua="n4k50r!";
		fwrite($backend, "<info>$ua</info>\n");
		fwrite($backend, "<message>".htmlentities($r["msg"])."</message>\n");
		fwrite($backend, "<login>".$r["user"]."</login>\n");
		fwrite($backend, "</post>\n");
	}
	fwrite($backend, "</board>\n");
	fclose($backend);
}

function genindex() {
	global $histsize;
	$ifile="trib-cache.html";
	$f=fopen($ifile,"w");
	fwrite($f, get_msgs($histsize, "coincoin"));
	fclose($f);
}



?>
